setup-ipsec-vpn/extras/vpnupgrade_centos.sh

259 lines
6.8 KiB
Bash
Raw Normal View History

2016-01-08 10:03:56 +01:00
#!/bin/sh
#
2016-04-21 00:31:29 +02:00
# Script to upgrade Libreswan on CentOS and RHEL
2016-01-08 10:03:56 +01:00
#
2018-05-06 01:49:38 +02:00
# Copyright (C) 2016-2018 Lin Song <linsongui@gmail.com>
2016-01-08 10:03:56 +01:00
#
# This work is licensed under the Creative Commons Attribution-ShareAlike 3.0
# Unported License: http://creativecommons.org/licenses/by-sa/3.0/
#
# Attribution required: please include my name in any derivative and let me
# know how you have improved it!
2016-07-20 20:10:58 +02:00
# Check https://libreswan.org for the latest version
SWAN_VER=3.22
2016-01-08 10:03:56 +01:00
2016-11-07 02:30:53 +01:00
### DO NOT edit below this line ###
2016-01-21 18:50:35 +01:00
export PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"
2016-11-07 02:30:53 +01:00
exiterr() { echo "Error: $1" >&2; exit 1; }
2017-11-01 07:01:49 +01:00
exiterr2() { exiterr "'yum install' failed."; }
vpnupgrade() {
if ! grep -qs -e "release 6" -e "release 7" /etc/redhat-release; then
2016-06-29 09:40:52 +02:00
exiterr "This script only supports CentOS/RHEL 6 and 7."
2016-01-08 10:03:56 +01:00
fi
2016-01-30 20:12:15 +01:00
if [ -f /proc/user_beancounters ]; then
2017-11-01 07:01:49 +01:00
exiterr "OpenVZ VPS is not supported."
2016-01-19 08:32:22 +01:00
fi
2016-01-08 10:03:56 +01:00
if [ "$(id -u)" != 0 ]; then
2016-06-29 09:40:52 +02:00
exiterr "Script must be run as root. Try 'sudo sh $0'"
2016-01-08 10:03:56 +01:00
fi
2017-11-01 07:01:49 +01:00
if [ -z "$SWAN_VER" ]; then
exiterr "Libreswan version 'SWAN_VER' not specified."
2016-06-21 05:35:45 +02:00
fi
swan_ver_is_supported=0
case "$SWAN_VER" in
3.19|3.2[01235])
swan_ver_is_supported=1
;;
esac
if [ "$swan_ver_is_supported" != "1" ]; then
exiterr "Libreswan version $SWAN_VER is not supported."
fi
ipsec_ver="$(/usr/local/sbin/ipsec --version 2>/dev/null)"
if ! printf '%s' "$ipsec_ver" | grep -q "Libreswan"; then
2016-06-29 09:40:52 +02:00
exiterr "This script requires Libreswan already installed."
2016-01-08 10:03:56 +01:00
fi
if printf '%s' "$ipsec_ver" | grep -qF "$SWAN_VER"; then
2017-11-01 07:01:49 +01:00
echo "You already have Libreswan version $SWAN_VER installed! "
echo "If you continue, the same version will be re-installed."
2016-01-08 10:03:56 +01:00
echo
printf "Do you wish to continue anyway? [y/N] "
read -r response
2016-01-08 10:03:56 +01:00
case $response in
[yY][eE][sS]|[yY])
echo
;;
*)
echo "Aborting."
exit 1
;;
esac
fi
is_upgrade_to_323_or_newer=0
case "$SWAN_VER" in
3.2[35])
if ! printf '%s' "$ipsec_ver" | grep -qF -e "3.23" -e "3.25"; then
is_upgrade_to_323_or_newer=1
fi
;;
esac
is_downgrade_to_322_or_older=0
case "$SWAN_VER" in
3.19|3.2[012])
if printf '%s' "$ipsec_ver" | grep -qF -e "3.23" -e "3.25"; then
is_downgrade_to_322_or_older=1
fi
;;
esac
2016-01-18 19:37:09 +01:00
clear
2016-05-21 10:59:08 +02:00
cat <<EOF
2017-11-01 07:01:49 +01:00
Welcome! This script will build and install Libreswan $SWAN_VER on your server.
Additional packages required for compilation will also be installed.
It is intended for upgrading servers to a newer Libreswan version.
2016-05-21 10:59:08 +02:00
Current version: $ipsec_ver
Version to be installed: Libreswan $SWAN_VER
EOF
case "$SWAN_VER" in
3.2[35])
cat <<'EOF'
WARNING: Libreswan 3.23 and 3.25 have an issue with connecting multiple
IPsec/XAuth VPN clients from behind the same NAT (e.g. home router).
DO NOT upgrade to 3.23/3.25 if your use cases include the above.
EOF
;;
esac
cat <<'EOF'
NOTE: Libreswan versions 3.19 and newer require some configuration changes.
This script will make the following updates to your /etc/ipsec.conf:
1. Replace "auth=esp" with "phase2=esp"
2. Replace "forceencaps=yes" with "encapsulation=yes"
3. Consolidate VPN ciphers for "ike=" and "phase2alg=",
re-add "MODP1024" to the list of allowed "ike=" ciphers,
which was removed from the defaults in Libreswan 3.19.
Your other VPN configuration files will not be modified.
2016-05-21 10:59:08 +02:00
EOF
2016-01-08 10:03:56 +01:00
printf "Do you wish to continue? [y/N] "
read -r response
2016-01-08 10:03:56 +01:00
case $response in
[yY][eE][sS]|[yY])
echo
echo "Please be patient. Setup is continuing..."
echo
;;
*)
echo "Aborting."
exit 1
;;
esac
# Create and change to working dir
mkdir -p /opt/src
2018-05-23 08:39:53 +02:00
cd /opt/src || exit 1
2016-01-08 10:03:56 +01:00
2016-01-21 18:50:35 +01:00
# Install Wget
2016-07-04 00:54:15 +02:00
yum -y install wget || exiterr2
2016-01-08 10:03:56 +01:00
# Add the EPEL repository
epel_url="https://dl.fedoraproject.org/pub/epel/epel-release-latest-$(rpm -E '%{rhel}').noarch.rpm"
yum -y install epel-release || yum -y install "$epel_url" || exiterr2
2016-01-08 10:03:56 +01:00
# Install necessary packages
yum -y install nss-devel nspr-devel pkgconfig pam-devel \
2017-11-01 07:01:49 +01:00
libcap-ng-devel libselinux-devel curl-devel \
flex bison gcc make || exiterr2
2016-01-08 10:03:56 +01:00
REPO1='--enablerepo=*server-optional*'
REPO2='--enablerepo=*releases-optional*'
2016-01-08 10:03:56 +01:00
if grep -qs "release 6" /etc/redhat-release; then
yum -y remove libevent-devel
yum "$REPO1" "$REPO2" -y install libevent2-devel fipscheck-devel || exiterr2
else
yum -y install systemd-devel || exiterr2
yum "$REPO1" "$REPO2" -y install libevent-devel fipscheck-devel || exiterr2
2016-01-08 10:03:56 +01:00
fi
# Compile and install Libreswan
2017-11-01 07:01:49 +01:00
swan_file="libreswan-$SWAN_VER.tar.gz"
swan_url1="https://github.com/libreswan/libreswan/archive/v$SWAN_VER.tar.gz"
swan_url2="https://download.libreswan.org/$swan_file"
2016-10-11 05:34:51 +02:00
if ! { wget -t 3 -T 30 -nv -O "$swan_file" "$swan_url1" || wget -t 3 -T 30 -nv -O "$swan_file" "$swan_url2"; }; then
2018-05-23 08:39:53 +02:00
exit 1
2016-10-11 05:34:51 +02:00
fi
2017-11-01 07:01:49 +01:00
/bin/rm -rf "/opt/src/libreswan-$SWAN_VER"
2016-05-21 12:34:19 +02:00
tar xzf "$swan_file" && /bin/rm -f "$swan_file"
2018-05-23 08:39:53 +02:00
cd "libreswan-$SWAN_VER" || exit 1
[ "$SWAN_VER" = "3.22" ] && sed -i '/^#define LSWBUF_CANARY/s/-2$/((char) -2)/' include/lswlog.h
sed -i '/docker-targets\.mk/d' Makefile
2017-08-20 17:52:28 +02:00
cat > Makefile.inc.local <<'EOF'
WERROR_CFLAGS =
USE_DNSSEC = false
USE_GLIBC_KERN_FLIP_HEADERS = true
2017-08-20 17:52:28 +02:00
EOF
NPROCS="$(grep -c ^processor /proc/cpuinfo)"
[ -z "$NPROCS" ] && NPROCS=1
make "-j$((NPROCS+1))" -s base && make -s install-base
2016-01-08 10:03:56 +01:00
2016-06-04 00:10:03 +02:00
# Verify the install and clean up
2018-05-23 08:39:53 +02:00
cd /opt/src || exit 1
2017-11-01 07:01:49 +01:00
/bin/rm -rf "/opt/src/libreswan-$SWAN_VER"
if ! /usr/local/sbin/ipsec --version 2>/dev/null | grep -qF "$SWAN_VER"; then
exiterr "Libreswan $SWAN_VER failed to build."
2016-10-11 05:34:51 +02:00
fi
2016-06-04 00:10:03 +02:00
# Restore SELinux contexts
2016-04-21 00:31:29 +02:00
restorecon /etc/ipsec.d/*db 2>/dev/null
restorecon /usr/local/sbin -Rv 2>/dev/null
restorecon /usr/local/libexec/ipsec -Rv 2>/dev/null
# Update ipsec.conf
IKE_NEW=" ike=3des-sha1,3des-sha2,aes-sha1,aes-sha1;modp1024,aes-sha2,aes-sha2;modp1024"
PHASE2_NEW=" phase2alg=3des-sha1,3des-sha2,aes-sha1,aes-sha2,aes256-sha2_512"
2017-11-01 07:01:49 +01:00
sed -i".old-$(date +%F-%T)" \
-e "s/^[[:space:]]\+auth=esp\$/ phase2=esp/" \
-e "s/^[[:space:]]\+forceencaps=yes\$/ encapsulation=yes/" \
-e "s/^[[:space:]]\+ike=.\+\$/$IKE_NEW/" \
-e "s/^[[:space:]]\+phase2alg=.\+\$/$PHASE2_NEW/" /etc/ipsec.conf
2016-01-20 06:17:18 +01:00
# Restart IPsec service
mkdir -p /run/pluto
2016-04-21 00:31:29 +02:00
service ipsec restart
2016-01-08 10:03:56 +01:00
echo
2017-11-01 07:01:49 +01:00
echo "Libreswan $SWAN_VER was installed successfully! "
2016-04-21 00:31:29 +02:00
echo
2016-05-21 10:59:08 +02:00
if [ "$is_upgrade_to_323_or_newer" = "1" ]; then
2018-02-11 08:05:13 +01:00
cat <<'EOF'
IMPORTANT: Users upgrading to Libreswan 3.23 or newer must edit
/etc/ipsec.conf and replace these two lines:
modecfgdns1=DNS_SERVER_1
modecfgdns2=DNS_SERVER_2
with a single line like this:
modecfgdns="DNS_SERVER_1, DNS_SERVER_2"
Then run "service ipsec restart".
2018-02-11 08:05:13 +01:00
EOF
fi
2018-02-11 08:05:13 +01:00
if [ "$is_downgrade_to_322_or_older" = "1" ]; then
cat <<'EOF'
IMPORTANT: Users downgrading to Libreswan 3.22 or older must edit
/etc/ipsec.conf and replace this line:
modecfgdns="DNS_SERVER_1, DNS_SERVER_2"
with two lines like this:
modecfgdns1=DNS_SERVER_1
modecfgdns2=DNS_SERVER_2
Then run "service ipsec restart".
EOF
fi
}
## Defer setup until we have the complete script
vpnupgrade "$@"
2016-01-08 10:03:56 +01:00
exit 0